glibmm: Gio::DBus::AuthObserver Class Reference

glibmm 2.82.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gio::DBus::AuthObserver Class Reference
D-Bus API

AuthObserver - An object used for authenticating connections. More...

`#include <giomm/dbusauthobserver.h>`

Inheritance diagram for Gio::DBus::AuthObserver:
[legend]

## Public Member Functions
| AuthObserver (AuthObserver && src) noexcept
AuthObserver & | operator= (AuthObserver && src) noexcept
| ~AuthObserver () noexcept override
GDBusAuthObserver * | gobj ()
| Provides access to the underlying C GObject.
const GDBusAuthObserver * | gobj () const
| Provides access to the underlying C GObject.
GDBusAuthObserver * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
bool | authorize_authenticated_peer (const Glib::RefPtr< const IOStream > &stream, const Glib::RefPtr< const Credentials > & credentials)
| Emits the Gio::DBus::AuthObserver::signal_authorize_authenticated_peer() signal on observer.
bool | allow_mechanism (const std::string & mechanism)
| Emits the Gio::DBus::AuthObserver::signal_allow_mechanism() signal on observer.
Glib::SignalProxy< bool(const Glib::RefPtr< const IOStream > &, const Glib::RefPtr< const Credentials > &)> | signal_authorize_authenticated_peer ()
Glib::SignalProxy< bool(const std::string &)> | signal_allow_mechanism ()
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object && src) noexcept
Object & | operator= (Object && src) noexcept
void * | get_data (const QueryQuark & key)
void | set_data (const Quark & key, void *data)
void | set_data_with_c_callback (const Quark & key, void *data, GDestroyNotify notify)
void | set_data (const Quark & key, void *data, DestroyNotify notify)
| Prefer set_data_with_c_callback() with a callback with C linkage.
void | remove_data (const QueryQuark & quark)
void * | steal_data (const QueryQuark & quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring & property_name, const Glib::ValueBase & value)
| You probably want to use a specific property_*() accessor method instead.
void | get_property_value (const Glib::ustring & property_name, Glib::ValueBase & value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | set_property (const Glib::ustring & property_name, const PropertyType & value)
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | get_property (const Glib::ustring & property_name, PropertyType & value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
PropertyType | get_property (const Glib::ustring & property_name) const
| You probably want to use a specific property_*() accessor method instead.
sigc::connection | connect_property_changed (const Glib::ustring & property_name, const sigc::slot< void()> & slot)
| You can use the signal_changed() signal of the property proxy instead.
sigc::connection | connect_property_changed (const Glib::ustring & property_name, sigc::slot< void()> && slot)
| You can use the signal_changed() signal of the property proxy instead.
void | freeze_notify ()
| Increases the freeze count on object.
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify().
virtual void | reference () const
| Increment the reference count for this object.
virtual void | unreference () const
| Decrement the reference count for this object.
GObject * | gobj ()
| Provides access to the underlying C GObject.
const GObject * | gobj () const
| Provides access to the underlying C GObject.
GObject * | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access.

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< AuthObserver > | create ()

## Protected Member Functions
| AuthObserver ()
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams & construct_params)
| Object (GObject * castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor.
| ObjectBase (const char * custom_type_name)
| A derived constructor always overrides this choice.
| ObjectBase (const std::type_info & custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually.
| ObjectBase (ObjectBase && src) noexcept
ObjectBase & | operator= (ObjectBase && src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject * castitem)
void | initialize_move (GObject * castitem, Glib::ObjectBase * previous_wrapper)

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gio::DBus::AuthObserver > | wrap (GDBusAuthObserver * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject * object, bool take_copy=false)

## Additional Inherited Members
Public Types inherited from Glib::Object
using | DestroyNotify = void (*)(gpointer data)

## Detailed Description

AuthObserver - An object used for authenticating connections.

The AuthObserver type provides a mechanism for participating in how a Server (or a Connection) authenticates remote peers. Simply instantiate an AuthObserver and connect to the signals you are interested in. Note that new signals may be added in the future.

For example, if you only want to allow D-Bus connections from processes owned by the same uid as the server, you would use a signal handler like the following:

bool on_authorize_authenticated_peer(
const Glib::RefPtr<const Gio::IOStream>&,
const Glib::RefPtr<const Gio::Credentials>& credentials)
{
bool authorized = false;
if (credentials)
{
Glib::RefPtr<Gio::Credentials> own_credentials = Gio::Credentials::create();
try
{
if (credentials->is_same_user(own_credentials))
authorized = true;
}
catch (const Gio::Error& ex)
{
std::cerr << "Gio::Error: " << ex.what() << std::endl;
}
}
return authorized;
}
std::endl
basic_ostream< _CharT, _Traits > & endl(basic_ostream< _CharT, _Traits > &__os)
std::cerr
ostream cerr
std::shared_ptr
Gio::Credentials::create
static Glib::RefPtr< Credentials > create()
Gio::Error
Exception class for giomm errors.
Definition error.h:51
Glib::Error::what
const char * what() const noexcept override

Since glibmm 2.28

## Constructor & Destructor Documentation

## ◆ AuthObserver() [1/2]

Gio::DBus::AuthObserver::AuthObserver | ( | AuthObserver && | src | ) |
| noexcept

## ◆ ~AuthObserver()

Gio::DBus::AuthObserver::~AuthObserver | ( |  | ) |
| overridenoexcept

## ◆ AuthObserver() [2/2]

Gio::DBus::AuthObserver::AuthObserver | ( |  | ) |
| protected

## Member Function Documentation

## ◆ allow_mechanism()

bool Gio::DBus::AuthObserver::allow_mechanism | ( | const std::string & | mechanism | ) |

Emits the Gio::DBus::AuthObserver::signal_allow_mechanism() signal on observer.

Since glibmm 2.34

Parameters

  mechanism | The name of the mechanism, e.g. `DBUS_COOKIE_SHA1`.

Returns
  `true` if mechanism can be used to authenticate the other peer, `false` if not.

## ◆ authorize_authenticated_peer()

bool Gio::DBus::AuthObserver::authorize_authenticated_peer | ( | const Glib::RefPtr< const IOStream > & | stream,
|  | const Glib::RefPtr< const Credentials > & | credentials )

Emits the Gio::DBus::AuthObserver::signal_authorize_authenticated_peer() signal on observer.

Since glibmm 2.26

Parameters

  stream | A IOStream for the Gio::DBus::Connection.
  credentials | Credentials received from the peer or `nullptr`.

Returns
  `true` if the peer is authorized, `false` if not.

## ◆ create()

static Glib::RefPtr< AuthObserver > Gio::DBus::AuthObserver::create | ( |  | ) |
| static

## ◆ get_type()

static GType Gio::DBus::AuthObserver::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GDBusAuthObserver * Gio::DBus::AuthObserver::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GDBusAuthObserver * Gio::DBus::AuthObserver::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GDBusAuthObserver * Gio::DBus::AuthObserver::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

AuthObserver & Gio::DBus::AuthObserver::operator= | ( | AuthObserver && | src | ) |
| noexcept

## ◆ signal_allow_mechanism()

Glib::SignalProxy< bool(const std::string &)> Gio::DBus::AuthObserver::signal_allow_mechanism | ( |  | ) |

Slot Prototype:
  `bool on_my_allow_mechanism(const std::string& mechanism)`

Flags: Run Last

Emitted to check if mechanism is allowed to be used.

Since glibmm 2.34

Parameters

  mechanism | The name of the mechanism, e.g. `DBUS_COOKIE_SHA1`.

Returns
  `true` if mechanism can be used to authenticate the other peer, `false` if not.

## ◆ signal_authorize_authenticated_peer()

Glib::SignalProxy< bool(const Glib::RefPtr< const IOStream > &, const Glib::RefPtr< const Credentials > &)> Gio::DBus::AuthObserver::signal_authorize_authenticated_peer | ( |  | ) |

Slot Prototype:
  `bool on_my_authorize_authenticated_peer(const Glib::RefPtr<const IOStream>& stream, const Glib::RefPtr<const Credentials>& credentials)`

Flags: Run Last

Emitted to check if a peer that is successfully authenticated is authorized.

Since glibmm 2.26

Parameters

  stream | A IOStream for the Gio::DBus::Connection.
  credentials | Credentials received from the peer or `nullptr`.

Returns
  `true` if the peer is authorized, `false` if not.

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gio::DBus::AuthObserver > wrap | ( | GDBusAuthObserver * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.